#include <stdio.h>
#include <string.h>
#define TAM   100

struct lista {
  char *nome;
  struct lista *prox;
};
typedef struct lista * LISTA;

/* cria um item da lista */
LISTA criaItem ()
{
  LISTA item;
  item = (LISTA) malloc (sizeof(struct lista));
  item->nome = item->prox = NULL;
  return item;
}
/*Encontra o item na lista cujo nome eh indicado */
LISTA achaItem (char *nome, LISTA inicio)
{
  LISTA lista = inicio;
  while (lista && strcmp (lista->nome, nome))
    lista = lista->prox;
  return lista;
}
/*Insere um novo nome na lista */
void insereItem (char *nome, LISTA inicio)
{
  LISTA novo;
  novo = criaItem();
  novo->nome = strdup(nome); /* cria uma copia de nome */
  novo->prox = inicio->prox;
  inicio->prox = novo;
}
/* Remove da lista o item com o nome indicado */
void removeItem (char *nome, LISTA inicio)
{
  LISTA lista, prev = inicio;
  
  lista = achaItem (nome, inicio);

  while (prev->prox != lista)
      prev = prev->prox;
    prev->prox = lista->prox;
}
/* Programa Principal. Obtem nomes, insere em lista e depois remove */
main ()
{
  char buffer[100];
  LISTA itens;
  itens = criaItem();
  do {
    printf ("Entre um nome: ");
    fgets (buffer, 100, stdin);
    if (strcmp(buffer,"FIM\n")) {
      insereItem (buffer, itens);
    }
  } while (strcmp(buffer,"FIM\n"));

  do {
    printf ("Indique nome a remover: ");
    fgets (buffer, 100, stdin);
    if (strcmp(buffer,"FIM\n")) {
      removeItem (buffer, itens);
    }
  } while (strcmp(buffer,"FIM\n"));
}
